Index: issm/trunk/src/c/objects/IoModel.cpp
===================================================================
--- issm/trunk/src/c/objects/IoModel.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/IoModel.cpp	(revision 9405)
@@ -1005,2 +983,63 @@
 	xfree((void**)&string);
 }
+/*FUNCTION IoModel::SetFilePointerToData{{{1*/
+FILE* IoModel::SetFilePointerToData(int* pcode,int* pvector_type, int data_enum){
+
+	extern int my_rank;
+	extern int num_procs;
+	
+	int found=0;
+	int record_enum;
+	int record_length;
+	int record_code; //1 to 7 number
+	int vector_type; //nodal or elementary
+ 
+	/*Go find in the binary file, the position of the data we want to fetch: */
+	if(my_rank==0){
+	
+		/*First set FILE* position to the beginning of the file: */
+		fseek(fid,0,SEEK_SET);
+
+		/*Now march through file looking for the correct data identifier: */
+		for(;;){
+			/*Read enum for this size of first string name: */
+			if(fread(&record_enum,sizeof(int),1,fid)==0){
+				/*Ok, we have reached the end of the file. break: */
+				found=0;
+				break;
+			}
+			
+			/*Is this the record sought for? : */
+			if (data_enum==record_enum){
+				/*Ok, we have found the correct string. Pass the record length, and read data type code: */
+				fseek(fid,sizeof(int),SEEK_CUR);
+				fread(&record_code,sizeof(int),1,fid);
+
+				/*if record_code points to a vector, get its type (nodal or elementary): */
+				if(5<=record_code && record_code<=7)fread(&vector_type,sizeof(int),1,fid);
+				found=1;
+				break;
+			}
+			else{
+				/*This is not the correct string, read the record length, and use it to skip this record: */
+				fread(&record_length,sizeof(int),1,fid);
+				/*skip: */
+				fseek(fid,record_length,SEEK_CUR);
+			}
+		}
+	}
+	MPI_Bcast(&found,1,MPI_INT,0,MPI_COMM_WORLD); 
+	if(!found)_error_("%s %s ","could not find data with name",EnumToStringx(data_enum));
+
+	/*Broadcast code and vector type: */
+	MPI_Bcast(&record_code,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&vector_type,1,MPI_INT,0,MPI_COMM_WORLD); 
+	if(record_code==5) MPI_Bcast(&vector_type,1,MPI_INT,0,MPI_COMM_WORLD); 
+
+	/*Assign output pointers:*/
+	*pcode=record_code;
+	if(pvector_type)*pvector_type=vector_type;
+
+	return fid;
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/IoModel.h
===================================================================
--- issm/trunk/src/c/objects/IoModel.h	(revision 9403)
+++ issm/trunk/src/c/objects/IoModel.h	(revision 9405)
@@ -17,10 +17,9 @@
 
 	private: 
-		FILE    *fid; //pointer to input file
-		double **data;//this dataset holds temporary data, memory intensive.
+		FILE        *fid;         //pointer to input file
+		double     **data;        //this dataset holds temporary data, memory intensive.
+		Parameters  *constants;   //this dataset holds all double, int, bool and char *parameters read in from the input file.*
 
 	public:
-		Parameters *constants;   //this dataset holds all double, int, bool and char*parameters read in from the input file.*
-
 		/*This data needs to stay memory resident at all time, even if it's memory intensive: */
 		bool *my_elements;
@@ -35,26 +34,28 @@
 		int constraintcounter;   //keep track of how many constraints are being created in each analysis type
 
-		/*Methods: {{{1*/
+		/*Methods*/
 		~IoModel();
 		IoModel();
 		IoModel(FILE* iomodel_handle);
-		/*}}}*/
-		/*Input/Output:{{{1*/
-		void  FetchData(bool*     pboolean,int data_enum);
-		void  FetchData(int*      pinteger,int data_enum);
-		void  FetchData(double*   pscalar,int data_enum);
-		void  FetchData(char**    pstring,int data_enum);
-		void  FetchData(int** pmatrix,int* pM,int* pN,int data_enum);
-		void  FetchData(double**  pscalarmatrix,int* pM,int* pN,int data_enum);
-		void  FetchData(char***   pstringarray,int* pnumstrings,int data_enum);
-		void  FetchData(double*** pmatrixarray,int** pmdims,int** pndims, int* pnumrecords,int data_enum);
-		void  FetchParameters(Parameters* parameters);
-		FILE* SetFilePointerToData(int* pcode,int* pvector_type, int data_enum);
-		void  FetchDataToInput(Elements* elements,int vector_enum,int default_vector_enum=NoneEnum,double default_value=0);
-		void  FetchData(int num,...);
-		double* f(int dataenum);
-		void  DeleteData(int num,...);
-		/*}}}*/
 
+		/*Input/Output*/
+		void        Constant(bool   *poutput,int constant_enum);
+		void        Constant(int    *poutput,int constant_enum);
+		void        Constant(double *poutput,int constant_enum);
+		Parameters *CopyConstants(void);
+		double     *Data(int dataenum);
+		void        DeleteData(int num,...);
+		void        FetchConstants(void);
+		void        FetchData(bool*     pboolean,int data_enum);
+		void        FetchData(int*      pinteger,int data_enum);
+		void        FetchData(double*   pscalar,int data_enum);
+		void        FetchData(char**    pstring,int data_enum);
+		void        FetchData(int** pmatrix,int* pM,int* pN,int data_enum);
+		void        FetchData(double**  pscalarmatrix,int* pM,int* pN,int data_enum);
+		void        FetchData(char***   pstringarray,int* pnumstrings,int data_enum);
+		void        FetchData(double*** pmatrixarray,int** pmdims,int** pndims, int* pnumrecords,int data_enum);
+		void        FetchData(int num,...);
+		void        FetchDataToInput(Elements* elements,int vector_enum,int default_vector_enum=NoneEnum,double default_value=0);
+		FILE*       SetFilePointerToData(int* pcode,int* pvector_type, int data_enum);
 };
 
Index: issm/trunk/src/c/objects/Loads/Icefront.cpp
===================================================================
--- issm/trunk/src/c/objects/Loads/Icefront.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Loads/Icefront.cpp	(revision 9405)
@@ -54,6 +54,6 @@
 	
 	/*find parameters: */
-	iomodel->constants->FindParam(&dim,DimEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&dim,DimEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
 
 	/*First, retrieve element index and element type: */
@@ -64,20 +64,20 @@
 		segment_width=6;
 	}
-	_assert_(iomodel->f(PressureloadEnum));
-	element=(int)(*(iomodel->f(PressureloadEnum)+segment_width*i+segment_width-2)-1); //element is in the penultimate column (node1 node2 ... elem fill)
+	_assert_(iomodel->Data(PressureloadEnum));
+	element=(int)(*(iomodel->Data(PressureloadEnum)+segment_width*i+segment_width-2)-1); //element is in the penultimate column (node1 node2 ... elem fill)
 
 	/*Build ids for hook constructors: */
-	icefront_eid=(int) *(iomodel->f(PressureloadEnum)+segment_width*i+segment_width-2); //matlab indexing
+	icefront_eid=(int) *(iomodel->Data(PressureloadEnum)+segment_width*i+segment_width-2); //matlab indexing
 	icefront_mparid=numberofelements+1; //matlab indexing
 
 	if (in_icefront_type==MacAyeal2dIceFrontEnum || in_icefront_type==MacAyeal3dIceFrontEnum){
-		icefront_node_ids[0]=iomodel->nodecounter+(int)*(iomodel->f(PressureloadEnum)+segment_width*i+0);
-		icefront_node_ids[1]=iomodel->nodecounter+(int)*(iomodel->f(PressureloadEnum)+segment_width*i+1);
+		icefront_node_ids[0]=iomodel->nodecounter+(int)*(iomodel->Data(PressureloadEnum)+segment_width*i+0);
+		icefront_node_ids[1]=iomodel->nodecounter+(int)*(iomodel->Data(PressureloadEnum)+segment_width*i+1);
 	}
 	else if (in_icefront_type==PattynIceFrontEnum || in_icefront_type==StokesIceFrontEnum){
-		icefront_node_ids[0]=iomodel->nodecounter+(int)*(iomodel->f(PressureloadEnum)+segment_width*i+0);
-		icefront_node_ids[1]=iomodel->nodecounter+(int)*(iomodel->f(PressureloadEnum)+segment_width*i+1);
-		icefront_node_ids[2]=iomodel->nodecounter+(int)*(iomodel->f(PressureloadEnum)+segment_width*i+2);
-		icefront_node_ids[3]=iomodel->nodecounter+(int)*(iomodel->f(PressureloadEnum)+segment_width*i+3);
+		icefront_node_ids[0]=iomodel->nodecounter+(int)*(iomodel->Data(PressureloadEnum)+segment_width*i+0);
+		icefront_node_ids[1]=iomodel->nodecounter+(int)*(iomodel->Data(PressureloadEnum)+segment_width*i+1);
+		icefront_node_ids[2]=iomodel->nodecounter+(int)*(iomodel->Data(PressureloadEnum)+segment_width*i+2);
+		icefront_node_ids[3]=iomodel->nodecounter+(int)*(iomodel->Data(PressureloadEnum)+segment_width*i+3);
 	}
 	else _error_("in_icefront_type %s not supported yet!",EnumToStringx(in_icefront_type));
@@ -85,5 +85,5 @@
 	if (in_icefront_type==PattynIceFrontEnum || in_icefront_type==StokesIceFrontEnum) num_nodes=4;
 	else num_nodes=2;
-	icefront_fill=(int)*(iomodel->f(PressureloadEnum)+segment_width*i+segment_width-1); 
+	icefront_fill=(int)*(iomodel->Data(PressureloadEnum)+segment_width*i+segment_width-1); 
 	
 	/*Ok, we have everything to build the object: */
Index: issm/trunk/src/c/objects/Loads/Numericalflux.cpp
===================================================================
--- issm/trunk/src/c/objects/Loads/Numericalflux.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Loads/Numericalflux.cpp	(revision 9405)
@@ -54,5 +54,5 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
 
 	/* Get MatPar id */
@@ -60,7 +60,7 @@
 
 	/*First, see wether this is an internal or boundary edge (if e2=NaN)*/
-	if (isnan((double)iomodel->f(EdgesEnum)[4*i+3])){ //edges are [node1 node2 elem1 elem2]
+	if (isnan((double)iomodel->Data(EdgesEnum)[4*i+3])){ //edges are [node1 node2 elem1 elem2]
 		/* Boundary edge, only one element */
-		e1=(int)iomodel->f(EdgesEnum)[4*i+2];
+		e1=(int)iomodel->Data(EdgesEnum)[4*i+2];
 		e2=(int)UNDEF;
 		num_elems=1;
@@ -71,6 +71,6 @@
 	else{
 		/* internal edge: connected to 2 elements */
-		e1=(int)iomodel->f(EdgesEnum)[4*i+2];
-		e2=(int)iomodel->f(EdgesEnum)[4*i+3];
+		e1=(int)iomodel->Data(EdgesEnum)[4*i+2];
+		e2=(int)iomodel->Data(EdgesEnum)[4*i+3];
 		num_elems=2;
 		num_nodes=4;
@@ -81,6 +81,6 @@
 
 	/*1: Get vertices ids*/
-	i1=(int)iomodel->f(EdgesEnum)[4*i+0];
-	i2=(int)iomodel->f(EdgesEnum)[4*i+1];
+	i1=(int)iomodel->Data(EdgesEnum)[4*i+0];
+	i2=(int)iomodel->Data(EdgesEnum)[4*i+1];
 
 	if (numericalflux_type==InternalEnum){
@@ -91,8 +91,8 @@
 		pos1=pos2=pos3=pos4=UNDEF;
 		for(j=0;j<3;j++){
-			if (iomodel->f(ElementsEnum)[3*(e1-1)+j]==i1) pos1=j+1;
-			if (iomodel->f(ElementsEnum)[3*(e1-1)+j]==i2) pos2=j+1;
-			if (iomodel->f(ElementsEnum)[3*(e2-1)+j]==i1) pos3=j+1;
-			if (iomodel->f(ElementsEnum)[3*(e2-1)+j]==i2) pos4=j+1;
+			if (iomodel->Data(ElementsEnum)[3*(e1-1)+j]==i1) pos1=j+1;
+			if (iomodel->Data(ElementsEnum)[3*(e1-1)+j]==i2) pos2=j+1;
+			if (iomodel->Data(ElementsEnum)[3*(e2-1)+j]==i1) pos3=j+1;
+			if (iomodel->Data(ElementsEnum)[3*(e2-1)+j]==i2) pos4=j+1;
 		}
 		_assert_(pos1!=UNDEF && pos2!=UNDEF && pos3!=UNDEF && pos4!=UNDEF);
@@ -110,6 +110,6 @@
 		pos1=pos2=UNDEF;
 		for(j=0;j<3;j++){
-			if (iomodel->f(ElementsEnum)[3*(e1-1)+j]==i1) pos1=j+1;
-			if (iomodel->f(ElementsEnum)[3*(e1-1)+j]==i2) pos2=j+1;
+			if (iomodel->Data(ElementsEnum)[3*(e1-1)+j]==i1) pos1=j+1;
+			if (iomodel->Data(ElementsEnum)[3*(e1-1)+j]==i2) pos2=j+1;
 		}
 		_assert_(pos1!=UNDEF && pos2!=UNDEF);
Index: issm/trunk/src/c/objects/Loads/Pengrid.cpp
===================================================================
--- issm/trunk/src/c/objects/Loads/Pengrid.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Loads/Pengrid.cpp	(revision 9405)
@@ -53,6 +53,6 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&numberofvertices,NumberOfVerticesEnum);
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&numberofvertices,NumberOfVerticesEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
 
 	/*Some checks if debugging activated*/
Index: issm/trunk/src/c/objects/Loads/Riftfront.cpp
===================================================================
--- issm/trunk/src/c/objects/Loads/Riftfront.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Loads/Riftfront.cpp	(revision 9405)
@@ -56,13 +56,13 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&numberofelements,NumberOfElementsEnum);
-	iomodel->constants->FindParam(&penalty_lock,PenaltyLockEnum);
+	iomodel->Constant(&numberofelements,NumberOfElementsEnum);
+	iomodel->Constant(&penalty_lock,PenaltyLockEnum);
 
 	/*Ok, retrieve all the data needed to add a penalty between the two nodes: */
-	el1=(int)*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+2);
-	el2=(int)*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+3); 
-
-	node1=(int)*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+0); 
-	node2=(int)*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+1);
+	el1=(int)*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+2);
+	el2=(int)*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+3); 
+
+	node1=(int)*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+0); 
+	node2=(int)*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+1);
 
 	/*id: */
@@ -89,9 +89,9 @@
 	this->penalty_lock=penalty_lock;
 	this->material_converged=0;
-	this->normal[0]=*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+4);
-	this->normal[1]=*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+5);
-	this->length=*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+6);
-	this->fraction=*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+9);
-	this->state=(int)*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+11);
+	this->normal[0]=*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+4);
+	this->normal[1]=*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+5);
+	this->length=*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+6);
+	this->fraction=*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+9);
+	this->state=(int)*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+11);
 
 	//intialize inputs, and add as many inputs per element as requested: 
@@ -99,8 +99,8 @@
 		
 	riftfront_type=SegmentRiftfrontEnum;
-	riftfront_fill = (int)*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+7);
-	riftfront_friction=*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+8);
-	riftfront_fractionincrement=*(iomodel->f(RiftinfoEnum)+RIFTINFOSIZE*i+10);
-	riftfront_shelf=(bool)iomodel->f(NodeOnIceShelfEnum)[node1-1];
+	riftfront_fill = (int)*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+7);
+	riftfront_friction=*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+8);
+	riftfront_fractionincrement=*(iomodel->Data(RiftinfoEnum)+RIFTINFOSIZE*i+10);
+	riftfront_shelf=(bool)iomodel->Data(NodeOnIceShelfEnum)[node1-1];
 
 	this->inputs->AddInput(new IntInput(TypeEnum,riftfront_type));
Index: issm/trunk/src/c/objects/Materials/Matice.cpp
===================================================================
--- issm/trunk/src/c/objects/Materials/Matice.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Materials/Matice.cpp	(revision 9405)
@@ -660,7 +660,7 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&dim,DimEnum);
-	iomodel->constants->FindParam(&control_analysis,ControlAnalysisEnum);
-	iomodel->constants->FindParam(&num_control_type,NumControlTypeEnum);
+	iomodel->Constant(&dim,DimEnum);
+	iomodel->Constant(&control_analysis,ControlAnalysisEnum);
+	iomodel->Constant(&num_control_type,NumControlTypeEnum);
 
 	/*if 2d*/
@@ -674,25 +674,25 @@
 
 		/*Get B*/
-		if (iomodel->f(RheologyBEnum)) {
-			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->f(RheologyBEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+i]-1)];
+		if (iomodel->Data(RheologyBEnum)) {
+			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->Data(RheologyBEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+i]-1)];
 			this->inputs->AddInput(new TriaVertexInput(RheologyBbarEnum,nodeinputs));
 		}
 
 		/*Get n*/
-		if (iomodel->f(RheologyNEnum)) {
-			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->f(RheologyNEnum)[index];
+		if (iomodel->Data(RheologyNEnum)) {
+			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->Data(RheologyNEnum)[index];
 			this->inputs->AddInput(new TriaVertexInput(RheologyNEnum,nodeinputs));
 		}
 
 		/*Control Inputs*/
-		if (control_analysis && iomodel->f(ControlTypeEnum)){
+		if (control_analysis && iomodel->Data(ControlTypeEnum)){
 			for(i=0;i<num_control_type;i++){
-				switch((int)iomodel->f(ControlTypeEnum)[i]){
+				switch((int)iomodel->Data(ControlTypeEnum)[i]){
 					case RheologyBbarEnum:
-						if (iomodel->f(RheologyBEnum)){
-							_assert_(iomodel->f(RheologyBEnum));_assert_(iomodel->f(CmMinEnum)); _assert_(iomodel->f(CmMaxEnum)); 
-							for(j=0;j<num_vertices;j++)nodeinputs[j]=iomodel->f(RheologyBEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+j]-1)];
-							for(j=0;j<num_vertices;j++)cmmininputs[j]=iomodel->f(CmMinEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
-							for(j=0;j<num_vertices;j++)cmmaxinputs[j]=iomodel->f(CmMaxEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
+						if (iomodel->Data(RheologyBEnum)){
+							_assert_(iomodel->Data(RheologyBEnum));_assert_(iomodel->Data(CmMinEnum)); _assert_(iomodel->Data(CmMaxEnum)); 
+							for(j=0;j<num_vertices;j++)nodeinputs[j]=iomodel->Data(RheologyBEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+j]-1)];
+							for(j=0;j<num_vertices;j++)cmmininputs[j]=iomodel->Data(CmMinEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
+							for(j=0;j<num_vertices;j++)cmmaxinputs[j]=iomodel->Data(CmMaxEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
 							this->inputs->AddInput(new ControlInput(RheologyBbarEnum,TriaVertexInputEnum,nodeinputs,cmmininputs,cmmaxinputs,i+1));
 						}
@@ -713,25 +713,25 @@
 
 		/*Get B*/
-		if (iomodel->f(RheologyBEnum)) {
-			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->f(RheologyBEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+i]-1)];
+		if (iomodel->Data(RheologyBEnum)) {
+			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->Data(RheologyBEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+i]-1)];
 			this->inputs->AddInput(new PentaVertexInput(RheologyBEnum,nodeinputs));
 		}
 
 		/*Get n*/
-		if (iomodel->f(RheologyNEnum)) {
-			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->f(RheologyNEnum)[index];
+		if (iomodel->Data(RheologyNEnum)) {
+			for(i=0;i<num_vertices;i++) nodeinputs[i]=iomodel->Data(RheologyNEnum)[index];
 			this->inputs->AddInput(new PentaVertexInput(RheologyNEnum,nodeinputs));
 		}
 
 		/*Control Inputs*/
-		if (control_analysis && iomodel->f(ControlTypeEnum)){
+		if (control_analysis && iomodel->Data(ControlTypeEnum)){
 			for(i=0;i<num_control_type;i++){
-				switch((int)iomodel->f(ControlTypeEnum)[i]){
+				switch((int)iomodel->Data(ControlTypeEnum)[i]){
 					case RheologyBbarEnum:
-						if (iomodel->f(RheologyBEnum)){
-							_assert_(iomodel->f(RheologyBEnum));_assert_(iomodel->f(CmMinEnum)); _assert_(iomodel->f(CmMaxEnum)); 
-							for(j=0;j<num_vertices;j++)nodeinputs[j]=iomodel->f(RheologyBEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+j]-1)];
-							for(j=0;j<num_vertices;j++)cmmininputs[j]=iomodel->f(CmMinEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
-							for(j=0;j<num_vertices;j++)cmmaxinputs[j]=iomodel->f(CmMaxEnum)[int(iomodel->f(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
+						if (iomodel->Data(RheologyBEnum)){
+							_assert_(iomodel->Data(RheologyBEnum));_assert_(iomodel->Data(CmMinEnum)); _assert_(iomodel->Data(CmMaxEnum)); 
+							for(j=0;j<num_vertices;j++)nodeinputs[j]=iomodel->Data(RheologyBEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+j]-1)];
+							for(j=0;j<num_vertices;j++)cmmininputs[j]=iomodel->Data(CmMinEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
+							for(j=0;j<num_vertices;j++)cmmaxinputs[j]=iomodel->Data(CmMaxEnum)[int(iomodel->Data(ElementsEnum)[num_vertices*index+j]-1)*num_control_type+i];
 							this->inputs->AddInput(new ControlInput(RheologyBEnum,PentaVertexInputEnum,nodeinputs,cmmininputs,cmmaxinputs,i+1));
 						}
Index: issm/trunk/src/c/objects/Materials/Matpar.cpp
===================================================================
--- issm/trunk/src/c/objects/Materials/Matpar.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Materials/Matpar.cpp	(revision 9405)
@@ -26,21 +26,21 @@
 
 	this->mid                       = matpar_mid;
-	iomodel->constants->FindParam(&this->rho_ice,RhoIceEnum);
-	iomodel->constants->FindParam(&this->rho_water,RhoWaterEnum);
-	iomodel->constants->FindParam(&this->heatcapacity,HeatcapacityEnum);
-	iomodel->constants->FindParam(&this->thermalconductivity,ThermalconductivityEnum);
-	iomodel->constants->FindParam(&this->latentheat,LatentheatEnum);
-	iomodel->constants->FindParam(&this->beta,BetaEnum);
-	iomodel->constants->FindParam(&this->meltingpoint,MeltingpointEnum);
-	iomodel->constants->FindParam(&this->referencetemperature,ReferencetemperatureEnum);
-	iomodel->constants->FindParam(&this->mixed_layer_capacity,MixedLayerCapacityEnum);
-	iomodel->constants->FindParam(&this->thermal_exchange_velocity,ThermalExchangeVelocityEnum);
-	iomodel->constants->FindParam(&this->g,GEnum);
-	
-	iomodel->constants->FindParam(&this->kn,HydroKnEnum);
-	iomodel->constants->FindParam(&this->hydro_p,HydroPEnum);
-	iomodel->constants->FindParam(&this->hydro_q,HydroQEnum);
-	iomodel->constants->FindParam(&this->hydro_CR,HydroCREnum);
-	iomodel->constants->FindParam(&this->hydro_n,HydroNEnum);
+	iomodel->Constant(&this->rho_ice,RhoIceEnum);
+	iomodel->Constant(&this->rho_water,RhoWaterEnum);
+	iomodel->Constant(&this->heatcapacity,HeatcapacityEnum);
+	iomodel->Constant(&this->thermalconductivity,ThermalconductivityEnum);
+	iomodel->Constant(&this->latentheat,LatentheatEnum);
+	iomodel->Constant(&this->beta,BetaEnum);
+	iomodel->Constant(&this->meltingpoint,MeltingpointEnum);
+	iomodel->Constant(&this->referencetemperature,ReferencetemperatureEnum);
+	iomodel->Constant(&this->mixed_layer_capacity,MixedLayerCapacityEnum);
+	iomodel->Constant(&this->thermal_exchange_velocity,ThermalExchangeVelocityEnum);
+	iomodel->Constant(&this->g,GEnum);
+	
+	iomodel->Constant(&this->kn,HydroKnEnum);
+	iomodel->Constant(&this->hydro_p,HydroPEnum);
+	iomodel->Constant(&this->hydro_q,HydroQEnum);
+	iomodel->Constant(&this->hydro_CR,HydroCREnum);
+	iomodel->Constant(&this->hydro_n,HydroNEnum);
 }
 /*}}}1*/
Index: issm/trunk/src/c/objects/Node.cpp
===================================================================
--- issm/trunk/src/c/objects/Node.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Node.cpp	(revision 9405)
@@ -37,5 +37,5 @@
 
 	/*Fetch parameters: */
-	iomodel->constants->FindParam(&dim,DimEnum);
+	iomodel->Constant(&dim,DimEnum);
 
 	/*id: */
@@ -46,5 +46,5 @@
 
 	/*indexing:*/
-	DistributeNumDofs(&this->indexing,analysis_type,iomodel->f(VerticesTypeEnum)+io_index); //number of dofs per node
+	DistributeNumDofs(&this->indexing,analysis_type,iomodel->Data(VerticesTypeEnum)+io_index); //number of dofs per node
 	gsize=this->indexing.gsize;
 
@@ -54,16 +54,16 @@
 	//intialize inputs, and add as many inputs per element as requested: 
 	this->inputs=new Inputs();
-	if (iomodel->f(NodeOnBedEnum))      this->inputs->AddInput(new BoolInput(NodeOnBedEnum,(IssmBool)iomodel->f(NodeOnBedEnum)[io_index]));
-	if (iomodel->f(NodeOnSurfaceEnum))  this->inputs->AddInput(new BoolInput(NodeOnSurfaceEnum,(IssmBool)iomodel->f(NodeOnSurfaceEnum)[io_index]));
-	if (iomodel->f(NodeOnIceShelfEnum)) this->inputs->AddInput(new BoolInput(NodeOnIceShelfEnum,(IssmBool)iomodel->f(NodeOnIceShelfEnum)[io_index]));
-	if (iomodel->f(NodeOnIceSheetEnum)) this->inputs->AddInput(new BoolInput(NodeOnIceSheetEnum,(IssmBool)iomodel->f(NodeOnIceSheetEnum)[io_index]));
+	if (iomodel->Data(NodeOnBedEnum))      this->inputs->AddInput(new BoolInput(NodeOnBedEnum,(IssmBool)iomodel->Data(NodeOnBedEnum)[io_index]));
+	if (iomodel->Data(NodeOnSurfaceEnum))  this->inputs->AddInput(new BoolInput(NodeOnSurfaceEnum,(IssmBool)iomodel->Data(NodeOnSurfaceEnum)[io_index]));
+	if (iomodel->Data(NodeOnIceShelfEnum)) this->inputs->AddInput(new BoolInput(NodeOnIceShelfEnum,(IssmBool)iomodel->Data(NodeOnIceShelfEnum)[io_index]));
+	if (iomodel->Data(NodeOnIceSheetEnum)) this->inputs->AddInput(new BoolInput(NodeOnIceSheetEnum,(IssmBool)iomodel->Data(NodeOnIceSheetEnum)[io_index]));
 	if (iomodel->numbernodetoelementconnectivity) this->inputs->AddInput(new IntInput(NumberNodeToElementConnectivityEnum,(IssmInt)iomodel->numbernodetoelementconnectivity[io_index]));
-	if (analysis_type==DiagnosticHorizAnalysisEnum) this->inputs->AddInput(new IntInput(ApproximationEnum,(IssmInt)iomodel->f(VerticesTypeEnum)[io_index]));
+	if (analysis_type==DiagnosticHorizAnalysisEnum) this->inputs->AddInput(new IntInput(ApproximationEnum,(IssmInt)iomodel->Data(VerticesTypeEnum)[io_index]));
 	
 	/*set single point constraints: */
 
 	/*spc all nodes on water*/
-	if (!iomodel->f(NodeOnWaterEnum)) _error_("iomodel->nodeonwater is NULL");
-	if (iomodel->f(NodeOnWaterEnum)[io_index]){
+	if (!iomodel->Data(NodeOnWaterEnum)) _error_("iomodel->nodeonwater is NULL");
+	if (iomodel->Data(NodeOnWaterEnum)[io_index]){
 		for(k=1;k<=gsize;k++){
 			this->FreezeDof(k);
@@ -75,16 +75,16 @@
 		if (dim==3){
 			/*We have a  3d mesh, we may have collapsed elements, hence dead nodes. Freeze them out: */
-			if (!iomodel->f(NodeOnBedEnum)) _error_("iomodel->nodeonbed is NULL");
-			if (!iomodel->f(VerticesTypeEnum)) _error_("iomodel->vertices_type is NULL");
-			if (iomodel->f(VerticesTypeEnum)[io_index]==MacAyealApproximationEnum && !iomodel->f(NodeOnBedEnum)[io_index]){
+			if (!iomodel->Data(NodeOnBedEnum)) _error_("iomodel->nodeonbed is NULL");
+			if (!iomodel->Data(VerticesTypeEnum)) _error_("iomodel->vertices_type is NULL");
+			if (iomodel->Data(VerticesTypeEnum)[io_index]==MacAyealApproximationEnum && !iomodel->Data(NodeOnBedEnum)[io_index]){
 				for(k=1;k<=gsize;k++) this->FreezeDof(k);
 			}
-			if (iomodel->f(VerticesTypeEnum)[io_index]==MacAyealPattynApproximationEnum && iomodel->f(NodeOnMacayealEnum)[io_index]){
-				if(!iomodel->f(NodeOnBedEnum)[io_index]){
+			if (iomodel->Data(VerticesTypeEnum)[io_index]==MacAyealPattynApproximationEnum && iomodel->Data(NodeOnMacayealEnum)[io_index]){
+				if(!iomodel->Data(NodeOnBedEnum)[io_index]){
 					for(k=1;k<=gsize;k++) this->FreezeDof(k);
 				}
 			}
-			if (iomodel->f(VerticesTypeEnum)[io_index]==MacAyealStokesApproximationEnum && iomodel->f(NodeOnMacayealEnum)[io_index]){
-				if(!iomodel->f(NodeOnBedEnum)[io_index]){
+			if (iomodel->Data(VerticesTypeEnum)[io_index]==MacAyealStokesApproximationEnum && iomodel->Data(NodeOnMacayealEnum)[io_index]){
+				if(!iomodel->Data(NodeOnBedEnum)[io_index]){
 					for(k=1;k<=2;k++) this->FreezeDof(k);
 				}
@@ -92,6 +92,6 @@
 		}
 		/*spc all nodes on hutter*/
-		if (!iomodel->f(NodeOnHutterEnum)) _error_("iomodel->nodeonhutter is NULL");
-		if (iomodel->f(NodeOnHutterEnum)[io_index]){
+		if (!iomodel->Data(NodeOnHutterEnum)) _error_("iomodel->nodeonhutter is NULL");
+		if (iomodel->Data(NodeOnHutterEnum)[io_index]){
 			for(k=1;k<=gsize;k++){
 				this->FreezeDof(k);
@@ -104,6 +104,6 @@
 	if (analysis_type==DiagnosticHutterAnalysisEnum){
 		/*Constrain all nodes that are not Hutter*/
-		if (!iomodel->f(NodeOnHutterEnum)) _error_("iomodel->nodeonhutter is NULL");
-		if (!iomodel->f(NodeOnHutterEnum)[io_index]){
+		if (!iomodel->Data(NodeOnHutterEnum)) _error_("iomodel->nodeonhutter is NULL");
+		if (!iomodel->Data(NodeOnHutterEnum)[io_index]){
 			for(k=1;k<=gsize;k++){
 				this->FreezeDof(k);
@@ -122,6 +122,6 @@
 		if (dim==3){
 			/*On a 3d mesh, we may have collapsed elements, hence dead nodes. Freeze them out: */
-			_assert_(iomodel->f(NodeOnBedEnum));
-			if (!iomodel->f(NodeOnBedEnum)[io_index]){
+			_assert_(iomodel->Data(NodeOnBedEnum));
+			if (!iomodel->Data(NodeOnBedEnum)[io_index]){
 				for(k=1;k<=gsize;k++){
 					this->FreezeDof(k);
Index: issm/trunk/src/c/objects/Vertex.cpp
===================================================================
--- issm/trunk/src/c/objects/Vertex.cpp	(revision 9403)
+++ issm/trunk/src/c/objects/Vertex.cpp	(revision 9405)
@@ -31,5 +31,5 @@
 Vertex::Vertex(int vertex_id, int vertex_sid,int i, IoModel* iomodel){
 
-	this->Init(vertex_id, vertex_sid, iomodel->f(XEnum)[i],iomodel->f(YEnum)[i],iomodel->f(ZEnum)[i],(iomodel->f(ZEnum)[i]-iomodel->f(BedEnum)[i])/(iomodel->f(ThicknessEnum)[i]));
+	this->Init(vertex_id, vertex_sid, iomodel->Data(XEnum)[i],iomodel->Data(YEnum)[i],iomodel->Data(ZEnum)[i],(iomodel->Data(ZEnum)[i]-iomodel->Data(BedEnum)[i])/(iomodel->Data(ThicknessEnum)[i]));
 
 }
Index: issm/trunk/src/m/classes/model.m
===================================================================
--- issm/trunk/src/m/classes/model.m	(revision 9403)
+++ issm/trunk/src/m/classes/model.m	(revision 9405)
@@ -253,4 +253,5 @@
 		 %Results fields
 		 output_frequency                    = {0,true,'Integer'};
+		 results_on_vertices                 = {0,true,'Boolean'};
 		 inputfilename                       = {'',true,'String'};
 		 outputfilename                      = {'',true,'String'};
